欢迎您访问程序员文章站本站旨在为大家提供分享程序员计算机编程知识!
您现在的位置是: 首页  >  web前端

Codeforces Round #256 (Div. 2)D 二分答案_html/css_WEB-ITnose

程序员文章站 2022-06-16 10:49:38
...
D. Multiplication Table

time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Bizon the Champion isn't just charming, he also is very smart.

While some of us were learning the multiplication table, Bizon the Champion had fun in his own manner. Bizon the Champion painted ann?×?m multiplication table, where the element on the intersection of the i-th row and j-th column equals i·j (the rows and columns of the table are numbered starting from 1). Then he was asked: what number in the table is the k-th largest number? Bizon the Champion always answered correctly and immediately. Can you repeat his success?

Consider the given multiplication table. If you write out all n·m numbers from the table in the non-decreasing order, then the k-th number you write out is called the k-th largest number.

Input

The single line contains integers n, m and k (1?≤?n,?m?≤?5·105; 1?≤?k?≤?n·m).

Output

Print the k-th largest number in a n?×?m multiplication table.

Sample test(s)

input

2 2 2

output

input

2 3 4

output

input

1 10 5

output

Note

A 2?×?3 multiplication table looks like this:

1 2 32 4 6

题解

题目意思是,从一个n*m的乘法表(不要问我乘法表是什么)中选出第k小数(相同的数字会计算多次)。

比如样例 2 3 4

乘法表为

1 2 3

2 3 4

非减序列是:1, 2, 2, 3, 3, 4。第4个数字是3,所以输出3。

一开始我想到的是搜索,从n*m开始搜索,后来发现状态实在太多而且即便是搜索,时间复杂度是O(N * M)。

正确的解法是二分。二分答案(边界是[1, n * m]),然后在乘法表中去找比他小的数。因为乘法表是一个有规律的数表,所以针对每一列直接O(1)计算即可,总共计算N次。

总的时间复杂度是O(N * 2 * log(N))。

代码示例

/*****************************************************************************#       COPYRIGHT NOTICE#       Copyright (c) 2014 All rights reserved#       ----Stay Hungry Stay Foolish----##       @author       :Shen#       @name         :D#       @file         :D.cpp#       @date         :2014/07/17 22:47#       @algorithm    :Binary Search******************************************************************************///#pragma GCC optimize ("O2")//#pragma comment(linker, "/STACK:1024000000,1024000000")#include using namespace std;templateinline bool updateMin(T& a, T b){ return a > b ? a = b, 1: 0; }templateinline bool updateMax(T& a, T b){ return a > n >> m >> k;    int64 Right = n * m, Left = 1;    int64 ans = BinarySearch(Left, Right);    cout